<?php

/*
 * author Michael Richey
 * copyright Copyright © 2016 Michael Richey. All rights reserved.
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * Website http://www.gsuez.cl
 */
// no direct access

namespace RicheyWeb;

defined('_JEXEC') or die;
if (!class_exists('RicheyWeb/Singleton'))
{

    abstract class Singleton {

	protected static $m_pInstance;

	final public static function getInstance() {
	    $class = static::getClass();
	    if (!isset(static::$m_pInstance[$class]))
	    {
		static::$m_pInstance[$class] = new $class;
	    }
	    return static::$m_pInstance[$class];
	}

	final public static function getClass() {
	    return get_called_class();
	}

    }

}